'use strict';

module.exports = {
	IsPropertyDescriptor: 'http://ecma-international.org/ecma-262/8.0/#sec-property-descriptor-specification-type',
	IsAccessorDescriptor: 'http://ecma-international.org/ecma-262/8.0/#sec-isaccessordescriptor',
	IsDataDescriptor: 'http://ecma-international.org/ecma-262/8.0/#sec-isdatadescriptor',
	IsGenericDescriptor: 'http://ecma-international.org/ecma-262/8.0/#sec-isgenericdescriptor',
	FromPropertyDescriptor: 'http://ecma-international.org/ecma-262/8.0/#sec-frompropertydescriptor',
	ToPropertyDescriptor: 'http://ecma-international.org/ecma-262/8.0/#sec-topropertydescriptor',
	CompletePropertyDescriptor: 'http://ecma-international.org/ecma-262/8.0/#sec-completepropertydescriptor',
	ToPrimitive: 'http://ecma-international.org/ecma-262/8.0/#sec-toprimitive',
	ToBoolean: 'http://ecma-international.org/ecma-262/8.0/#sec-toboolean',
	ToNumber: 'http://ecma-international.org/ecma-262/8.0/#sec-tonumber',
	ToInteger: 'http://ecma-international.org/ecma-262/8.0/#sec-tointeger',
	ToInt32: 'http://ecma-international.org/ecma-262/8.0/#sec-toint32',
	ToUint32: 'http://ecma-international.org/ecma-262/8.0/#sec-touint32',
	ToInt16: 'http://ecma-international.org/ecma-262/8.0/#sec-toint16',
	ToUint16: 'http://ecma-international.org/ecma-262/8.0/#sec-touint16',
	ToInt8: 'http://ecma-international.org/ecma-262/8.0/#sec-toint8',
	ToUint8: 'http://ecma-international.org/ecma-262/8.0/#sec-touint8',
	ToUint8Clamp: 'http://ecma-international.org/ecma-262/8.0/#sec-touint8clamp',
	ToString: 'http://ecma-international.org/ecma-262/8.0/#sec-tostring',
	ToObject: 'http://ecma-international.org/ecma-262/8.0/#sec-toobject',
	ToPropertyKey: 'http://ecma-international.org/ecma-262/8.0/#sec-topropertykey',
	ToLength: 'http://ecma-international.org/ecma-262/8.0/#sec-tolength',
	CanonicalNumericIndexString: 'http://ecma-international.org/ecma-262/8.0/#sec-canonicalnumericindexstring',
	ToIndex: 'http://ecma-international.org/ecma-262/8.0/#sec-toindex',
	RequireObjectCoercible: 'http://ecma-international.org/ecma-262/8.0/#sec-requireobjectcoercible',
	IsArray: 'http://ecma-international.org/ecma-262/8.0/#sec-isarray',
	IsCallable: 'http://ecma-international.org/ecma-262/8.0/#sec-iscallable',
	IsConstructor: 'http://ecma-international.org/ecma-262/8.0/#sec-isconstructor',
	IsExtensible: 'http://ecma-international.org/ecma-262/8.0/#sec-isextensible-o',
	IsInteger: 'http://ecma-international.org/ecma-262/8.0/#sec-isinteger',
	IsPropertyKey: 'http://ecma-international.org/ecma-262/8.0/#sec-ispropertykey',
	IsRegExp: 'http://ecma-international.org/ecma-262/8.0/#sec-isregexp',
	SameValue: 'http://ecma-international.org/ecma-262/8.0/#sec-samevalue',
	SameValueZero: 'http://ecma-international.org/ecma-262/8.0/#sec-samevaluezero',
	SameValueNonNumber: 'http://ecma-international.org/ecma-262/8.0/#sec-samevaluenonnumber',
	Get: 'http://ecma-international.org/ecma-262/8.0/#sec-get-o-p',
	GetV: 'http://ecma-international.org/ecma-262/8.0/#sec-getv',
	Set: 'http://ecma-international.org/ecma-262/8.0/#sec-set-o-p-v-throw',
	CreateDataProperty: 'http://ecma-international.org/ecma-262/8.0/#sec-createdataproperty',
	CreateMethodProperty: 'http://ecma-international.org/ecma-262/8.0/#sec-createmethodproperty',
	CreateDataPropertyOrThrow: 'http://ecma-international.org/ecma-262/8.0/#sec-createdatapropertyorthrow',
	DefinePropertyOrThrow: 'http://ecma-international.org/ecma-262/8.0/#sec-definepropertyorthrow',
	DeletePropertyOrThrow: 'http://ecma-international.org/ecma-262/8.0/#sec-deletepropertyorthrow',
	GetMethod: 'http://ecma-international.org/ecma-262/8.0/#sec-getmethod',
	HasProperty: 'http://ecma-international.org/ecma-262/8.0/#sec-hasproperty',
	HasOwnProperty: 'http://ecma-international.org/ecma-262/8.0/#sec-hasownproperty',
	Call: 'http://ecma-international.org/ecma-262/8.0/#sec-call',
	Construct: 'http://ecma-international.org/ecma-262/8.0/#sec-construct',
	SetIntegrityLevel: 'http://ecma-international.org/ecma-262/8.0/#sec-setintegritylevel',
	TestIntegrityLevel: 'http://ecma-international.org/ecma-262/8.0/#sec-testintegritylevel',
	CreateArrayFromList: 'http://ecma-international.org/ecma-262/8.0/#sec-createarrayfromlist',
	CreateListFromArrayLike: 'http://ecma-international.org/ecma-262/8.0/#sec-createlistfromarraylike',
	Invoke: 'http://ecma-international.org/ecma-262/8.0/#sec-invoke',
	OrdinaryHasInstance: 'http://ecma-international.org/ecma-262/8.0/#sec-ordinaryhasinstance',
	SpeciesConstructor: 'http://ecma-international.org/ecma-262/8.0/#sec-speciesconstructor',
	EnumerableOwnProperties: 'http://ecma-international.org/ecma-262/8.0/#sec-enumerableownproperties',
	GetIterator: 'http://ecma-international.org/ecma-262/8.0/#sec-getiterator',
	IteratorNext: 'http://ecma-international.org/ecma-262/8.0/#sec-iteratornext',
	IteratorComplete: 'http://ecma-international.org/ecma-262/8.0/#sec-iteratorcomplete',
	IteratorValue: 'http://ecma-international.org/ecma-262/8.0/#sec-iteratorvalue',
	IteratorStep: 'http://ecma-international.org/ecma-262/8.0/#sec-iteratorstep',
	IteratorClose: 'http://ecma-international.org/ecma-262/8.0/#sec-iteratorclose',
	CreateIterResultObject: 'http://ecma-international.org/ecma-262/8.0/#sec-createiterresultobject',
	CreateListIterator: 'http://ecma-international.org/ecma-262/8.0/#sec-createlistiterator',
	Type: 'http://ecma-international.org/ecma-262/8.0/#sec-ecmascript-language-types',
	thisNumberValue: 'http://ecma-international.org/ecma-262/8.0/#sec-properties-of-the-number-prototype-object',
	thisTimeValue: 'http://ecma-international.org/ecma-262/8.0/#sec-properties-of-the-date-prototype-object',
	thisStringValue: 'http://ecma-international.org/ecma-262/8.0/#sec-properties-of-the-string-prototype-object',
	RegExpExec: 'http://ecma-international.org/ecma-262/8.0/#sec-regexpexec',
	RegExpBuiltinExec: 'http://ecma-international.org/ecma-262/8.0/#sec-regexpbuiltinexec',
	IsConcatSpreadable: 'http://ecma-international.org/ecma-262/8.0/#sec-isconcatspreadable',
	IsPromise: 'http://ecma-international.org/ecma-262/8.0/#sec-ispromise',
	ArraySpeciesCreate: 'http://ecma-international.org/ecma-262/8.0/#sec-arrayspeciescreate',
	AdvanceStringIndex: 'http://ecma-international.org/ecma-262/6.0/#sec-advancestringindex'
};
